<div class="action-group mt-3 mb-3">
  <app-input-filter (changeEvent)="applyFilter($event)" [placeholder]='filerPlaceholder'></app-input-filter>
  <div *ngIf="extendedFunctionality" class="btn-group mr-2 inline-display" role="group" aria-label="First group">
    <button class="btn-delete" mat-icon-button matTooltip="Delete Member"
      [disabled]="selection.selected.length ? false : true" (click)="onDeleteMembers()">
      <mat-icon class="plus">clear</mat-icon>
    </button>
    <button class="action-btn" mat-icon-button matTooltip="Add Member"
      (click)="openAddMemberDialog(addGlobalMemberDialog)">
      <mat-icon class="plus">add</mat-icon>
    </button>
  </div>
</div>

<div *ngIf="!dataLoaded" class="lds-dual-ring"></div>
<div [hidden]="!dataLoaded" class="mat-elevation-z8 table-container">
  <table mat-table class="table-min-width" [dataSource]="dataSource" matSort>

    <ng-container matColumnDef="select">
      <th mat-header-cell *matHeaderCellDef class="checkbox-column">
      </th>
      <td mat-cell *matCellDef="let row" class="w-4r">
        <mat-checkbox (click)="$event.stopPropagation()" (change)="$event ? selection.toggle(row) : null"
          [checked]="selection.isSelected(row)" [aria-label]="checkboxLabel(row)">
        </mat-checkbox>
      </td>
    </ng-container>

    <ng-container matColumnDef="image">
      <th mat-header-cell *matHeaderCellDef> </th>
      <td mat-cell *matCellDef="let row" class="w-4r">
        <img class="avatar" src="data:image/PNG;base64,{{row.image}}">
      </td>
    </ng-container>

    <ng-container matColumnDef="name">
      <th mat-header-cell *matHeaderCellDef mat-sort-header> Name </th>
      <td mat-cell *matCellDef="let row"> {{row.name}} </td>
    </ng-container>

    <ng-container matColumnDef="email">
      <th mat-header-cell *matHeaderCellDef mat-sort-header> Email </th>
      <td mat-cell *matCellDef="let row"> {{row.email}} </td>
    </ng-container>

    <ng-container matColumnDef="registerDate">
      <th mat-header-cell *matHeaderCellDef mat-sort-header> Register Date </th>
      <td mat-cell *matCellDef="let row"> {{row.registerDate}} </td>
    </ng-container>

    <ng-container matColumnDef="confirmation">
      <th mat-header-cell *matHeaderCellDef mat-sort-header> Confirmation </th>
      <td mat-cell *matCellDef="let row"> {{row.confirmation}}</td>
    </ng-container>

    <ng-container matColumnDef="role">
      <th mat-header-cell *matHeaderCellDef mat-sort-header> Role </th>
      <td mat-cell *matCellDef="let row"> {{row.role}} </td>
    </ng-container>

    <tr mat-header-row *matHeaderRowDef="displayedColumns"></tr>
    <tr mat-row *matRowDef="let row; columns: displayedColumns;" (click)="selection.toggle(row)">
    </tr>
  </table>

  <mat-paginator [pageSizeOptions]="[20]"></mat-paginator>
</div>

<ng-template #addGlobalMemberDialog>
  <h1 mat-dialog-title>Add New Member</h1>
  <div mat-dialog-content>
    <form autocomplete="off" (submit)="onAddMemberFormSubmit(addMember)" #addMember="ngForm">
      <div class="form-group">
        <label for="inputUsername">Username</label>
        <input type="text" class="form-control" id="inputUsername" #inputUsername="ngModel"
          (ngModelChange)="validateUsernameNotTaken($event)" placeholder="Username" name="inputUsername" ngModel
          required>
        <div *ngIf="usernameTaken" class="input-err-text"> Username already exist</div>
        <div *ngIf="inputUsername.invalid && (inputUsername.touched || addMember.submitted)">
          <div *ngIf="inputUsername.errors.required" class="input-err-text">Username is required.</div>
        </div>
      </div>
      <div class="form-group">
        <label for="inputEmail">Email</label>
        <input type="email" class="form-control" id="inputEmail" #inputEmail="ngModel" name="inputEmail"
          (ngModelChange)="validateEmailNotTaken($event)" placeholder="you@example.com" [pattern]="emailPattern" ngModel
          required>
        <div *ngIf="inputEmail.invalid && (inputEmail.touched || addMember.submitted)">
          <div *ngIf="inputEmail.errors.required" class="input-err-text">Email is required.</div>
          <div *ngIf="inputEmail.errors.pattern" class="input-err-text">Email should be like *@*.* format</div>
        </div>
        <div *ngIf="emailTaken" class="input-err-text"> Email already exist</div>
      </div>
      <div class="form-group">
        <label for="inputRole">Select role</label>
        <select name="inputRole" id="inputRole" class="form-control" #inputRole="ngModel" ngModel required>
          <option *ngFor="let role of roles" [value]="role.roleId" [selected]="role.roleName === 'Guest'">
            {{role.roleName}}
          </option>
        </select>
        <div *ngIf="inputRole.invalid && (inputRole.touched || addMember.submitted)">
          <div *ngIf="inputRole.errors.required" class="input-err-text">Role is required.</div>
        </div>
      </div>
      <button mat-button cdkFocusInitial class="create-button">Save</button>
    </form>
  </div>
</ng-template>